#include <FastLED.h>

#define LED_PIN  A9 //a define is just a substitution. where you see LED_PIN it inserts A9. Unlike an varible it can't be changed
#define MAX_BRIGHTNESS 20
#define NUM_LEDS 64

int interval1 = 100;
byte hue; //make it a bye so it automaticaly wraps around at 255
int hue_latch;

unsigned long current_millis;
unsigned long  previous_millis1 = 0;
int led_count;
int led1;
int led_mode = 1;

CRGB led_grid[NUM_LEDS]; // the array of led_grid CRGB is the special way they defined with fastled
//led_grid is jsut the name, like any other varible name.

void setup() {
  FastLED.addLeds<WS2812B, LED_PIN, GRB>(led_grid, NUM_LEDS); //setup the led_grid. This same linbe will be used for any code using the led grid without change
  FastLED.setBrightness( MAX_BRIGHTNESS );  //0 (0FF) - 255 (ABSURDLY BRIGHT)
  
  randomSeed(A8); //this makes the random() expresion closer to actually random. Otherwise it will go through the same sequence every time.
  //set it to an anlog pin with nothing attached
}


void loop()
{
  current_millis = millis();

  if (current_millis - previous_millis1 > interval1) {
    previous_millis1 = current_millis;

    if (led_mode == 1) {
      hue = random(255);  //fully random. all numbers between 0 and 255
    }
    if (led_mode == 2) {
      hue = random(100, 200); //green to purple. random(low boundry, high boundry);
    }
    if (led_mode == 3) { // up and down
      if (hue_latch == 1) {
        hue += random(10);
        if (hue > 90) {
          hue = 90;
          hue_latch = 0;
        }
      }
      if (hue_latch == 0) {
        hue -= random(10);
        if (hue < 10 ) {
          hue = 10;
          hue_latch = 1;
        }
      }
    }

    Serial.println(hue);

    led_grid[led_count]  = CHSV( hue, random(200, 255), 255);
    //"led_grid" is the array defined at the top. led_count is the positon to write the data to
    // (hue, saturation, brightness) all 0-255

    led1 = led_count + 1;
    if (led1 > NUM_LEDS - 1) {
      led1 = 0;
    }
    led_grid[led1]  = CHSV( 0, 0, 0);

    FastLED.setBrightness(MAX_BRIGHTNESS);  // change the brightness of everything
    FastLED.show();  // send the array data to the led_grid


    led_count++;
    if (led_count >= NUM_LEDS) {
      led_count = 0;
    }

  }


}





