#include <FastLED.h>

#define LED_PIN  A9 //a define is just a substitution. where you see LED_PIN it inserts A9. Unlike an varible it can't be changed
#define MAX_BRIGHTNESS 25
#define NUM_LEDS 64
int interval1 = 80;
byte hue;
int hue_latch;
unsigned long current_millis;         // will store the current "time"
unsigned long  previous_millis1 = 0;  // will store last time LED1 was updated
int led_count;
int distance = 127;
int orb_hue=90;
int orb_size = 12;
int orb[12] = {19, 20, 26, 27, 28, 29, 34, 35, 36, 37, 43, 44};

CRGB led_grid[NUM_LEDS];

void setup() {
  FastLED.addLeds<WS2812B, LED_PIN, GRB>(led_grid, NUM_LEDS); ////setup the leds. This same linbe will be used for any code using the led grid without change
  FastLED.setBrightness( MAX_BRIGHTNESS );  //0 (0FF) - 255 (ABSURDLY BRIGHT)
  
  randomSeed(A8); //this makes the random() expresion closer to actually random. Otherwise it will go through the same sequence every time.
  //set it to an anlog pin with nothing attached
}


void loop()
{
  current_millis = millis();

  if (current_millis - previous_millis1 > interval1) {
    previous_millis1 = current_millis;

    led_count++;
    if (led_count >= NUM_LEDS) {
      led_count = 0;
    }

    hue ++;

    Serial.println(hue);

    fill_gradient(led_grid, 0, CHSV( hue, 127, 255), NUM_LEDS - 1, CHSV( hue - distance, 255, 255));
    //array, start position,start color,end pos,end color
    //http://fastled.io/docs/3.1/group___colorutils.html#ga3144bb2bb66aeed33e20f4fdd6cc1a98
    
    for (int i; i < orb_size; i++) {
      led_grid[orb[i]]  = CHSV( 120, 255, 128);
    }


    FastLED.setBrightness(MAX_BRIGHTNESS);  // change the brightness of everything
    FastLED.show();  // send the array data to the leds

  }


}




