#include <FastLED.h>

#define LED_PIN  A9 //a define is just a substitution. where you see LED_PIN it inserts A9. Unlike an varible it can't be changed
#define MAX_BRIGHTNESS 25
#define NUM_LEDS 64

byte up_pin = 10;
byte left_pin = 7;
byte down_pin = 8;
byte right_pin = 9;

byte p_up, p_down, p_left, p_right;
byte c_up, c_down, c_left, c_right;

int interval1 = 40;
byte hue;
int hue_latch;
unsigned long current_millis;         // will store the current "time"
unsigned long  previous_millis1 = 0;  // will store last time LED1 was updated
int led_count;
int distance = 127;

int xpos = 4;
int ypos = 4;

CRGB led_grid[NUM_LEDS];

void setup() {
  FastLED.addLeds<WS2812B, LED_PIN, GRB>(led_grid, NUM_LEDS).setCorrection(TypicalSMD5050);
  FastLED.setBrightness( MAX_BRIGHTNESS );  //0 (0FF) - 255 (ABSURDLY BRIGHT)

  randomSeed(A8); //this makes the random() expresion closer to actually random. Otherwise it will go through the same sequence every time.
  //set it to an anlog pin with nothing attached

  pinMode(up_pin, INPUT_PULLUP);
  pinMode(down_pin, INPUT_PULLUP);
  pinMode(left_pin, INPUT_PULLUP);
  pinMode(right_pin, INPUT_PULLUP);

}


void loop()
{
  current_millis = millis();

  p_up = c_up;
  c_up = digitalRead(up_pin);
  if (c_up == 0 && p_up == 1) {
    ypos -= 1;
    if (ypos < 0) {
      ypos = 0;
    }
  }

  p_down = c_down;
  c_down = digitalRead(down_pin);
  if (c_down == 0 && p_down == 1) {
    ypos += 1;
    if (ypos > 7) {
      ypos = 7;
    }
  }

  p_left = c_left;
  c_left = digitalRead(left_pin);
  if (c_left == 0 && p_left == 1) {
    xpos -= 1;
    if (xpos < 0) {
      xpos = 0;
    }
  }

  p_right = c_right;
  c_right = digitalRead(right_pin);
  if (c_right == 0 && p_right == 1) {
    xpos += 1;
    if (xpos > 7) {
      xpos = 7;
    }
  }

  if (c_down == 0 && c_up==0) { // if these three buttons are down
    for (int i; i < NUM_LEDS; i++) {  
      led_grid[i]  = CHSV( 0, 0, 0); //turn all leds off
    }
  }

  if (current_millis - previous_millis1 > interval1) {
    previous_millis1 = current_millis;

    hue += random(10);

    Serial.println(hue);

    led_grid[xpos + (ypos * 8)]  = CHSV( hue, 255, 255); //turn one light at our position on


    FastLED.setBrightness(MAX_BRIGHTNESS);  // change the brightness of everything
    FastLED.show();  // send the array data to the leds

  }


}




